﻿/**
* 2次元ベジェ曲線 直線との交点
* test 5
* @author nutsu
*/

package {
	
	import flash.display.Graphics;
	import flash.geom.Point;
	import flash.utils.getTimer;
	
	public class BezjeSegmentTest5 extends BezjeSegmentTest1{
		
		/**
		* コンストラクタ
		*/
		public function BezjeSegmentTest5(){
			super();
			
		}
		
		/**
		*	描画
		*/
		protected override function draw():void{
			var line:Line = new Line( 1, -2, -10 );
			
			//
			graphics.clear();
			
			//補助線
			graphics.lineStyle( 0, 0x333333 );
			graphics.moveTo( handle_start.x, handle_start.y );
			graphics.lineTo( handle_ctrl.x, handle_ctrl.y );
			graphics.lineTo( handle_end.x, handle_end.y );
			
			//2次元ベジェ
			graphics.lineStyle( 0, 0xffffff );
			graphics.moveTo( handle_start.x, handle_start.y );
			graphics.curveTo( handle_ctrl.x, handle_ctrl.y, handle_end.x, handle_end.y );
			
			//直線
			graphics.moveTo( 0, line.fx(0) );
			graphics.lineTo( stage.stageWidth, line.fx(stage.stageWidth) );
			
			//var tmp:int = getTimer();
			//-------------------------------
			
			var bezje:Bezje2D = new Bezje2D( new Point(handle_start.x, handle_start.y),
			                                 new Point(handle_end.x, handle_end.y),
			                                 new Point(handle_ctrl.x, handle_ctrl.y));
			
			//交点t値
			var ts:Array = bezje.intersectionTByLine( line );
			
			plots.graphics.clear();
			plots.graphics.lineStyle( 0, 0xffffff );
			for( var i:int=0; i<ts.length; i++ ){
				plot( plots.graphics, bezje.f(ts[i]) );
			}
			
			//--------------------------------
			//trace( "time", getTimer()-tmp );
		}
		
		/**
		* プロット
		*/
		protected override function plot(g:Graphics,p:Point):void{
			g.beginFill( 0x333333 );
			g.drawCircle( p.x, p.y, 3 );
			g.endFill();
		}
	}
	
}

